Code

Opened 7 years ago

Closed 7 years ago

Last modified 7 years ago

#3297 closed defect (fixed)

newforms: Implement FileField and ImageField

Reported by: telenieko@… Owned by: russellm
Component: Forms Version: master
Severity: normal Keywords: newforms
Cc: elsdoerfer@…, matjaz.crnko@…, andrew@…, tomi.kyostila@…, bs1984@…, oyvind@…, jhilyard@…, dagurp@…, sandro@…, nick.lane.au@…, goliath.mailinglist@…, mpjung@…, bfults@…, ross@…, upadhyay@…, graham@…, jm.bugtracking@…, gary.wilson@…, silassewell@…, ugrossek@…, jhmsmits@…, alexander.solovyov@…, niels@…, luiz.vital@…, simon@…, django@…, dottedmag@…, eduardo.padoan@…, bryan@…, framos@…, drackett@…, django@…, sam@…, akaihol+djtick@… Triage Stage: Accepted
Has patch: yes Needs documentation: no
Needs tests: no Patch needs improvement: yes
Easy pickings: UI/UX:

Description

As far as I saw newforms does not yet implement File and Image Fields, hence there's no way to upload files with the newforms API.

I saw no ticket about that sohere it is ;)
marked blocker as when newforms replaces forms those won't be unusable with files ;)

Attachments (37)

quickie-file-uploads.diff (6.2 KB) - added by Andrew Sutherland <andrew@…> 7 years ago.
quick and dirty FileField support that appears to work
fixed-quickie-file-uploads.diff (5.7 KB) - added by Andrew Sutherland <andrew@…> 7 years ago.
fixed quickie implementation for FileFields
fixed2-quickie-file-uploads.diff (5.6 KB) - added by Andrew Sutherland <andrew@…> 7 years ago.
remove additional commit conditional check that shouldn't have existed
diff.txt (4.4 KB) - added by anonymous 7 years ago.
diff file with what you have to do to patch v4457
3297.patch (4.4 KB) - added by Marc Fargas <telenieko@…> 7 years ago.
diff.txt as patch, checked against trunk.
4490.patch (4.7 KB) - added by Øyvind Saltvik <oyvind.saltvik@…> 7 years ago.
Checked against trunk, made file saving overridable in filefield as newforms_save_file
4490.2.patch (5.0 KB) - added by Øyvind Saltvik <oyvind.saltvik@…> 7 years ago.
required validation + formfield_save_file
4549-with-tests.patch (8.2 KB) - added by Øyvind Saltvik <oyvind.saltvik@…> 7 years ago.
Added tests and updated to trunk
4549-with-tests.2.patch (8.1 KB) - added by Øyvind Saltvik <oyvind.saltvik@…> 7 years ago.
Removed one comment too many, fixed
4549-with-tests-and-imagefield.patch (9.2 KB) - added by Øyvind Saltvik <oyvind.saltvik@…> 7 years ago.
ImageField with validation added
4549-with-tests-and-imagefield.2.patch (9.2 KB) - added by Øyvind Saltvik <oyvind.saltvik@…> 7 years ago.
Better validationerrors
4549-with-more-tests-and-imagefield.patch (11.4 KB) - added by Øyvind Saltvik <oyvind@…> 7 years ago.
Added one more validator, fixed formfield_save_file, and better tests
4664-newforms-file-imagefield.diff (11.0 KB) - added by Øyvind Saltvik <oyvind.saltvik@…> 7 years ago.
Corrected for multiple model save() , like manipulators in #4609, updated for rev 4664
4700-newforms-file-imagefield.diff (11.2 KB) - added by boxed@… 7 years ago.
updated to handle fields not handled by the form
4700-newforms-file-imagefield.2.diff (11.6 KB) - added by Øyvind Saltvik <oyvind.saltvik@…> 7 years ago.
Refactored code to handle fields not handled by the form, and save files after all other fields
4722-newforms-file-imagefield.diff (11.3 KB) - added by David Danier <goliath.mailinglist@…> 7 years ago.
Alternative implementation, without the need to have some hidden field containing the current value
4722-newforms-file-imagefield.2.diff (10.3 KB) - added by David Danier <goliath.mailinglist@…> 7 years ago.
Uploaded the wrong patch, sorry...this is the right one
4921-newforms-file-imagefield.diff (11.5 KB) - added by David Danier <goliath.mailinglist@…> 7 years ago.
Patch without additional hidden field for current trunk (rev 4921)
5245-newforms-file-imagefield.diff (11.0 KB) - added by David Danier <goliath.mailinglist@…> 7 years ago.
Patch for current trunk, changes: clean_data -> cleaned_data and new formfield-method for model-fields
5245-newforms-file-imagefield.2.diff (9.6 KB) - added by David Danier <goliath.mailinglist@…> 7 years ago.
New patch, as the old deleted some tests (missed this first, sorry)
5268-newforms-file-imagefield.diff (8.6 KB) - added by pterk@… 7 years ago.
Diff against revision 5268.
filefield.diff (18.1 KB) - added by russellm 7 years ago.
Slight modifications to FileField and ImageField implementation; against [5428]
filefield_with_newforms_admin_integration.diff (21.0 KB) - added by Matthias Pronk <django@…> 7 years ago.
Russel's patch plus a few lines to integrate with newforms-admin
filefield_with_newforms_admin_integration_2.diff (20.3 KB) - added by Øyvind Saltvik <oyvind@…> 7 years ago.
Patch that fixes the issues i mentioned
filefield_with_newforms_admin_integration_cleaner.diff (20.2 KB) - added by Øyvind Saltvik <oyvind@…> 7 years ago.
Cleaner passing of request.POST and request.FILES in add_view and change_view
filefield_with_newforms_admin_integration_cleaner_updated_and_corrected.diff (20.2 KB) - added by Manuel Saelices <msaelices@…> 7 years ago.
A new patch updated to latest newform-admin branch. Not-required ImageField bug fixed. Patch made with Fidel Ramos
filefield_with_newforms_admin_integration_cleaner_updated_and_corrected.2.diff (20.3 KB) - added by Manuel Saelices <msaelices@…> 7 years ago.
A new patch updated to latest newform-admin branch. Not-required ImageField bug fixed. Patch made with Fidel Ramos
5722-newforms-file-imagefield.diff (8.8 KB) - added by stefan+django@… 7 years ago.
patch against current trunk
5741-newforms_adnin_filefield_with_newforms_admin_integration_save_last_proposal.diff (21.6 KB) - added by Øyvind Saltvik <oyvind@…> 7 years ago.
Updated to newforms admin 5741, proposal of new model field kwarg to allow some fields to be saved last. save_last=True
5741-newforms_admin_filefield_with_newforms_admin_integration_save_on_commit_proposal.diff (21.3 KB) - added by Øyvind Saltvik <oyvind@…> 7 years ago.
Save on commit seems like a better idea.
5741-newforms_admin_filefield_with_newforms_admin_integration_save_on_commit_proposal.2.diff (21.3 KB) - added by Øyvind Saltvik <oyvind@…> 7 years ago.
Missing paranthesis in last patch
5741-newforms_admin_filefield_with_newforms_admin_integration_save_on_commit_proposal.3.diff (21.3 KB) - added by Øyvind Saltvik <oyvind@…> 7 years ago.
cleaner code
5741-newforms_admin_filefield_with_newforms_admin_integration_save_on_commit_proposal_ugettext.diff (21.3 KB) - added by Øyvind Saltvik <oyvind@…> 7 years ago.
Validation using ugettext instead of gettext
5741-newforms_admin_filefield_with_newforms_admin_integration_save_later_proposal_signals.diff (21.1 KB) - added by Øyvind Saltvik <oyvind@…> 7 years ago.
Save later using non weak signals instead of save_instance modification.
5741-newforms_admin_filefield_with_newforms_admin_integration_save_later_proposal_signals.2.diff (21.6 KB) - added by Øyvind Saltvik <oyvind@…> 7 years ago.
This one actually works and has comments.
5741-newforms_admin_filefield_with_newforms_admin_integration_save_to_function_proposal.diff (21.9 KB) - added by Øyvind Saltvik <oyvind@…> 7 years ago.
Save to using a function
filefield-5779.diff (18.2 KB) - added by russellm 7 years ago.
File and Image fields, patch against trunk [5779]

Download all attachments as: .zip

Change History (113)

comment:1 Changed 7 years ago by adrian

  • Component changed from Core framework to django.newforms
  • priority changed from high to normal
  • Severity changed from blocker to normal

comment:2 Changed 7 years ago by adrian

  • Resolution set to worksforme
  • Status changed from new to closed

The FileInput widget supports <input type="file">.

comment:3 Changed 7 years ago by telenieko@…

Then, on form_for_model() shouldn't it use that widget instead of Char ? (On my last try it used a simple text box with no "Browse" button).
Gonna try later anyway ;)

comment:4 Changed 7 years ago by guioum

same problem with "forms.models.form_for_model" (revision 4325).

Output for the FileField:

<tr><th><label for="id_data">Data:</label></th><td><input type="text" name="data" id="id_data" /></td></tr>

comment:5 Changed 7 years ago by guioum

  • Resolution worksforme deleted
  • Status changed from closed to reopened

FYI:

>>> File._meta.fields[2].name
'data'
>>> File._meta.fields[2]
<django.db.models.fields.FileField object at 0xb778c6ac>

>>> f = forms.models.form_for_model(File).fields['data']
>>> f.widget
<django.newforms.widgets.TextInput object at 0xb66ebb2c>
>>> f.widget.input_type
'text'

Even with this small patch in "db/models/fields/init.py:

class FileField(Field):
...
    def formfield(self, initial=None):
        return forms.CharField(required=not self.blank, widget=forms.FileInput, label=capfirst(self.verbose_name), initial=initial)

... the field doesn't pass the validation. Output for the FileField was in oldforms:

<tr><th><label for="id_data_file">Data:</label></th><td><input type="file" id="id_data_file" name="data_file" /><input type="hidden" id="id_data" name="data" value="" /></td></tr>

(don't we need the hidden input in newforms?)

This is what I have in my template:

<form enctype="multipart/form-data" action="" method="post">
  <table class="form">
    {{ form }}
  </table>
  <input type="submit" value="Add File" />
</form>

comment:6 Changed 7 years ago by Marc Fargas <telenieko@…>

On my setup it doesn't seem to work without the hidden field.. ;(

comment:7 Changed 7 years ago by anonymous

  • milestone Version 1.0 deleted

Milestone Version 1.0 deleted

comment:8 Changed 7 years ago by SmileyChris

  • Triage Stage changed from Unreviewed to Accepted

Changed 7 years ago by Andrew Sutherland <andrew@…>

quick and dirty FileField support that appears to work

comment:9 Changed 7 years ago by Andrew Sutherland <andrew@…>

  • Cc andrew@… added

So, I jumped the gun to newforms without realizing FileFields wouldn't work right. Since newforms is otherwise delightful, I have whipped up a stop-gap implementation for myself and anyone else who misses their FileFields. I'm somewhat assuming that the newforms developers have a grand plan in mind for how this should actually work, and assuming this patch will be eventually mooted. As such, I haven't gone super-fancy. If you would like a fancier patch, feel free to let me know and I'll see what I can do.

Er, and I'm going to need to upload a new version of the patch because I accidentally left in part of some other patches I have applied. (I'm also running rediff this time...)

Changed 7 years ago by Andrew Sutherland <andrew@…>

fixed quickie implementation for FileFields

Changed 7 years ago by Andrew Sutherland <andrew@…>

remove additional commit conditional check that shouldn't have existed

comment:10 Changed 7 years ago by Marc Fargas <telenieko@…>

  • Has patch set

comment:11 Changed 7 years ago by Tomi Kyöstilä <tomi.kyostila@…>

  • Cc tomi.kyostila@… added

comment:12 Changed 7 years ago by anonymous

  • Cc bs1984@… added

comment:13 Changed 7 years ago by Øyvind Saltvik <oyvind@…>

  • Cc oyvind@… added

comment:14 Changed 7 years ago by Øyvind Saltvik <oyvind@…>

What would be great was if the filenames were decided before saving the models, then saved as that filename after all models are saved.

comment:15 Changed 7 years ago by Jeff Hilyard <jhilyard@…>

  • Cc jhilyard@… added

Changed 7 years ago by anonymous

diff file with what you have to do to patch v4457

comment:16 Changed 7 years ago by anonymous

  • Needs tests set
  • Patch needs improvement set
  • Triage Stage changed from Accepted to Unreviewed

Folks,
fixed2-quickie-file-uploads.diff didn't work for me, because it was for newforms-admin branch version 4421, and I'm using newforms-admin branch version 4457. So our tech lead fiddled, and made fixed2-quickie-file-uploads.diff work for 4457. Now, I'm not sure how to create a patch file, so I'm just sending the diff.

Mae

comment:17 Changed 7 years ago by Marc Fargas <telenieko@…>

  • Patch needs improvement unset
  • Triage Stage changed from Unreviewed to Accepted

Hi anonymous, the state "Accepted" should be left as is, it means "This has to be worked out and fixed". It should move then to "Ready for check-in" or be closed as invalid. If you look at this diagram you'll see there's no way back to Unreviwed!!

About the patch, if you are using a SVN checkout, simply run "svn diff > my_own_patch.patch" or "svn diff <your modified files> > my_own_patch.patch" that should leave you with a "my_own_patch.patch" file which contains the differences between your local copy and your current revision number. So please do 'svn up' before anything.

ALSO, make sure your patch applies to trunk! If not, leave a patch for trunk and if you like, another for newforms-admin. But make sure you don't brake patches for trunk, after all, unless otherwise specified a patch is to be applied to trunk.

PS: Removed the "patch needs improvement" as the patch on trunk applies fine, someone will have to deal with the conflict (adrian?) on newforms-admin if it gets checked-in, or it will need to be improved if adrian merges his branch before this ticket gets in.

Changed 7 years ago by Marc Fargas <telenieko@…>

diff.txt as patch, checked against trunk.

comment:18 Changed 7 years ago by anonymous

  • Cc dagurp@… added

Changed 7 years ago by Øyvind Saltvik <oyvind.saltvik@…>

Checked against trunk, made file saving overridable in filefield as newforms_save_file

comment:19 Changed 7 years ago by Øyvind Saltvik <oyvind.saltvik@…>

  • Patch needs improvement set

Patch does not work with prefixed forms.

Changed 7 years ago by Øyvind Saltvik <oyvind.saltvik@…>

required validation + formfield_save_file

comment:20 Changed 7 years ago by Øyvind Saltvik <oyvind@…>

  • Patch needs improvement unset

My bad, did work with prefixed forms just forgot to prefix the instanciated forms.

Added validation for required filefields.

Made the patch work more like filefields works in oldforms by making saving of files a method (formfield_save_file) of the fieldtype, instead of calling save_FIELD_file directly.

comment:21 Changed 7 years ago by anonymous

  • Cc sandro@… added

Changed 7 years ago by Øyvind Saltvik <oyvind.saltvik@…>

Added tests and updated to trunk

comment:22 Changed 7 years ago by Øyvind Saltvik <oyvind.saltvik@…>

  • Needs tests unset

Changed 7 years ago by Øyvind Saltvik <oyvind.saltvik@…>

Removed one comment too many, fixed

comment:23 Changed 7 years ago by Marc Fargas <telenieko@…>

The patch seems fine and has no known issues, can this be set as "Read for check-in"?

comment:24 Changed 7 years ago by Øyvind Saltvik <oyvind.saltvik@…>

Oops, validation of filefields has errors. How can the field know if it is a modelform or instanceform?

comment:25 Changed 7 years ago by Øyvind Saltvik <oyvind.saltvik@…>

Needs testing with form_for_instance.

Changed 7 years ago by Øyvind Saltvik <oyvind.saltvik@…>

ImageField with validation added

Changed 7 years ago by Øyvind Saltvik <oyvind.saltvik@…>

Better validationerrors

Changed 7 years ago by Øyvind Saltvik <oyvind@…>

Added one more validator, fixed formfield_save_file, and better tests

comment:26 Changed 7 years ago by Øyvind Saltvik <oyvind@…>

Seems to work fine now.

comment:27 Changed 7 years ago by anonymous

  • Cc support@… added

Changed 7 years ago by Øyvind Saltvik <oyvind.saltvik@…>

Corrected for multiple model save() , like manipulators in #4609, updated for rev 4664

comment:28 Changed 7 years ago by nick.lane.au@…

  • Cc nick.lane.au@… added; support@… removed

I assume support@… doesn't *really* want to hear about this.

comment:29 Changed 7 years ago by orestis@…

I'd like to point out that there is the FileInput widget, which is fine for _uploading_ a file, but for _displaying_ a file or an image, on should display a link/thumbnail/whatever.

So I made this little widget:

from django.newforms.widgets import Widget, smart_unicode
import os

class File(Widget):
    def render(self, name, value, attrs=None):
        if value is None or value=='': return u'No file uploaded'
            
        if value != '': value = smart_unicode(value) # Only add the 'value' attribute if a value is non-empty.
        
        return u'<a href="%s">%s</a>' % (value,os.path.basename(value))

It's very basic, and needs to be passed the absolute url of a file (easy for models using get_FIELD_url). But it works.

To use it, I define a separate field that uses it, and I manually set it to the model's data.

comment:30 Changed 7 years ago by boxed@…

django.newforms.models.save_instance() should ignore fields that are not in the data. This will make it easy to make your own forms manually that only handle some of the fields, then set the rest of the fields explicitly in your view. For example the automatically filled in width and height fields you can specify for a model ImageField should not be attempted to be set since they will get set by some other code.

I will attach my updated patch that has these two if-statements added :P

Changed 7 years ago by boxed@…

updated to handle fields not handled by the form

Changed 7 years ago by Øyvind Saltvik <oyvind.saltvik@…>

Refactored code to handle fields not handled by the form, and save files after all other fields

comment:31 Changed 7 years ago by David Danier <goliath.mailinglist@…>

  • Cc goliath.mailinglist@… added

As I think putting the current value out to the web could lead to issues and may not be secure enough (user can skip a required field or submit anything to the script, NEVER trust user-data).

So I rewrote the patch, to not need this additional <input> anymore:

  • newforms.form_for_instance() sets formfield.required to False for every FileField that has some file attached
  • Forms that are written by the user should imitate this behavior if they want to use FileFields (perhaps a generic function can be added to newforms.models to accomplish this?)

Note about the implementation:
This can be done using a different variable, too. I tried using formfield.has_file_attached. But you have a problem here with newforms.Field.clean(). It checks whether the value is in EMPTY_VALUES and raises an Exception regardless of formfield.has_file_attached. So you have to skip super(FileField, self).clean(value), which I considered hackish. (You could set self.required before calling this and reset it afterwards, but I think this is worse.)

I tried to update the tests as well, but am not sure if they work (No clue how to call them).

Attachment follows.

Changed 7 years ago by David Danier <goliath.mailinglist@…>

Alternative implementation, without the need to have some hidden field containing the current value

Changed 7 years ago by David Danier <goliath.mailinglist@…>

Uploaded the wrong patch, sorry...this is the right one

comment:32 Changed 7 years ago by Michael P. Jung

  • Cc mpjung@… added

The 4722-newforms-file-imagefield.2.diff patch doesn't work for me.

I get a "TypeError: <lambda>() takes exactly 3 arguments (4 given)" at /django/db/models/fields/init.py in formfield_save_file, line 668. I tried both, patching the latest SVN and patching revision 4722.

comment:33 Changed 7 years ago by David Danier <goliath.mailinglist@…>

Do you use any other patches? Does 4700-newforms-file-imagefield.2.diff work?
I don't see a problem, as the code works here (tested with 4722 and HEAD) and looks currect (see below).

save_$FIELDNAME_file() is defined in contribute_to_class(), line 638 using:

lambda instance, filename, raw_contents, save=True: instance._save_FIELD_file(self, filename, raw_contents, save)

This takes 3 parameters as the error states (the first is "self", so I didn't count it).

It is called in formfield_save_file() (defined on line 665), using:

func = getattr(new_object, 'save_%s_file' % self.name)
func(new_data[field_name]["filename"], new_data[field_name]["content"], save)

I only see the 3 needed parameters here, so where did the 4th came from?

Could you perhaps look at you code to see if it differs and/or post a stacktrace?
As I only removed the "[0]" from this method I'm very confused by this, the previous patch seemed to work fine and I didn't change any API or logic in this part of the code.

comment:34 Changed 7 years ago by anonymous

Oh my! I had a "from mymodule.django.models import EnhancedImageField as ImageField" in my model code. That class was not aware of the optional "save" argument and therefore caused the problem when used together with newforms. Lesson learned: When working with non-api-stable software make sure you read the changelogs and diffs carefully. ;-)

comment:35 Changed 7 years ago by Brad Fults <bfults@…>

  • Cc bfults@… added

comment:36 Changed 7 years ago by ross@…

  • Cc ross@… added

comment:37 Changed 7 years ago by upadhyay@…

  • Cc upadhyay@… added

comment:38 Changed 7 years ago by graham@…

  • Cc graham@… added
  • Has patch unset

comment:39 Changed 7 years ago by anonymous

  • Has patch set

comment:40 Changed 7 years ago by anonymous

  • Cc jm.bugtracking@… added

comment:41 Changed 7 years ago by sandro@…

The last patch against 4722 does not work for me. When uploading the form is not validated and complains I'm not providing the field that is hidden (the one that does not end in _file). I'm not sure if I should change something.

The original patch by Øyvind Saltvik 4700 works just fine.

comment:42 Changed 7 years ago by Simon G. <dev@…>

  • Triage Stage changed from Accepted to Ready for checkin

So the 4700 one is good to go?:

4700-newforms-file-imagefield.2.diff (11.6 kB) - added by Øyvind Saltvik <oyvind.saltvik...> on 03/10/07 12:11:36.
    Refactored code to handle fields not handled by the form, and save files after all other fields

comment:43 Changed 7 years ago by David Danier <goliath.mailinglist@…>

The 4700-patch has the problems stated in comment #31. It relies on user-input (the second form-field) to do validation. This is not clean and can lead to validation-problems.
As the djangoboook says:
"Never — under any circumstances — trust data from the browser."
(http://www.djangobook.com/en/beta/chapter20/)

4722 does mostly the same, but custom Forms need to set required to False on (already provided) FileField's itself. And of course it skips the additional hidden form-field, so I think the above error might be caused by some mixture of the old forms (or old patch) and the rewritten one. -> There is no check for the hidden field anymore.

Please consider adding 4722, as newforms is a good place to remove such unclean things from the code.

Btw.: I think both patches do not apply against the current trunk. I will provide an updated patch soon.

Changed 7 years ago by David Danier <goliath.mailinglist@…>

Patch without additional hidden field for current trunk (rev 4921)

comment:44 Changed 7 years ago by Gary Wilson <gary.wilson@…>

  • Cc gary.wilson@… added

comment:45 Changed 7 years ago by anonymous

  • Cc silassewell@… added
  • Triage Stage changed from Ready for checkin to Design decision needed

comment:46 Changed 7 years ago by anonymous

  • Cc ugrossek@… added

Changed 7 years ago by David Danier <goliath.mailinglist@…>

Patch for current trunk, changes: clean_data -> cleaned_data and new formfield-method for model-fields

Changed 7 years ago by David Danier <goliath.mailinglist@…>

New patch, as the old deleted some tests (missed this first, sorry)

Changed 7 years ago by pterk@…

Diff against revision 5268.

comment:47 Changed 7 years ago by pterk@…

Can confirm the patch works -- after much headscratching: Don't forget to pass FILES to the 'form-factory':

Here's how I got it to work:

ImageForm = forms.models.form_for_model(Image)
request.POST.update(request.FILES)
f = ImageForm(request.POST)

comment:48 Changed 7 years ago by anonymous

  • Cc jhmsmits@… added

comment:49 Changed 7 years ago by anonymous

  • Cc matjaz.crnko@… added

comment:50 Changed 7 years ago by Alexander Solovyov <alexander.solovyov@…>

  • Cc alexander.solovyov@… added

comment:51 Changed 7 years ago by anonymous

  • Cc niels@… added

comment:52 Changed 7 years ago by anonymous

  • Cc luiz.vital@… added

comment:53 Changed 7 years ago by sime <simon@…>

  • Cc simon@… added
  • Patch needs improvement set

Works beautifully. Only two issues I see, save() seems to save the file to disk before the database, which leaves filenames without an ID. Second, as somebody already pointed out, manually adding request.FILES to form data seems to be necessary. Newforms should take care of that.

Changed 7 years ago by russellm

Slight modifications to FileField and ImageField implementation; against [5428]

comment:54 Changed 7 years ago by russellm

  • Owner changed from adrian to russellm
  • Status changed from reopened to new
  • Triage Stage changed from Design decision needed to Accepted

I've just attached a slightly modified version of the FileField/ImageField patch. This version of the patch:

  • Modifies forms to take a "files" argument, for storage of file data. This means you no longer have to copy and update your POST dictionary on submit. You just call MyForm(request.POST, request.FILES)
  • Introduces an "UploadedFile" temporary object to store the submitted file data.
  • Modifies the internals of the form_for_model/instance save method to make field saving more generic, rather than making a special case of FileField. This should make writing custom fields with unusual save requirements much easier.

This patch now has 2 potential backwards incompatibilities:

  1. If you are relying upon auto_id being the 2nd argument on a form (rather than explicitly naming auto_id=False), your rendered forms will start adding label tags.
  2. If you have written any custom code using value_from_datadict, you will need to modify those implementations to handle the new files argument.

Changed 7 years ago by Matthias Pronk <django@…>

Russel's patch plus a few lines to integrate with newforms-admin

comment:55 Changed 7 years ago by Matthias Pronk <django@…>

  • Cc django@… added

This patch integrates Russel's patch with the admin of newforms-admin.

comment:56 Changed 7 years ago by Øyvind Saltvik <oyvind@…>

Just got a couple of issues with this latest patch.

No need to set widget in line 232, since it is already set by the formfield in the field.

Testing the code gives a error if you have not null constraints on other fields, because save is called when saving the file to disk before those values are set on the model.

request.FILES is passed even if it is not needed, not sure if that affects efficiency in any way.

Changed 7 years ago by Øyvind Saltvik <oyvind@…>

Patch that fixes the issues i mentioned

comment:57 Changed 7 years ago by anonymous

  • Cc dottedmag@… added

comment:58 Changed 7 years ago by anonymous

  • Cc eduardo.padoan@… added

Changed 7 years ago by Øyvind Saltvik <oyvind@…>

Cleaner passing of request.POST and request.FILES in add_view and change_view

comment:59 Changed 7 years ago by anonymous

  • Cc bryan@… added

Changed 7 years ago by Manuel Saelices <msaelices@…>

A new patch updated to latest newform-admin branch. Not-required ImageField bug fixed. Patch made with Fidel Ramos

Changed 7 years ago by Manuel Saelices <msaelices@…>

A new patch updated to latest newform-admin branch. Not-required ImageField bug fixed. Patch made with Fidel Ramos

comment:60 Changed 7 years ago by Fidel Ramos

  • Cc framos@… added

There's a bug in this patch. The clean method of ImageField is defined as:

class ImageField(FileField):
    def clean(self, data):
        """
        Checks that the file-upload field data contains a valid image (GIF, JPG,
        PNG, possibly others -- whatever the Python Imaging Library supports).
        """
        f = super(ImageField, self).clean(data)
        from PIL import Image
        from cStringIO import StringIO
        try:
            Image.open(StringIO(f.content))
        except IOError: # Python Imaging Library doesn't recognize it as an image
            raise ValidationError(gettext(u"Upload a valid image. The file you uploaded was either not an image or a corrupted image."))
        return f

I have a newforms with a not required ImageField, but if it's validated without uploading a file it fails with the following exception:

Exception Type:  	AttributeError
Exception Value: 	'NoneType' object has no attribute 'content'
Exception Location: 	/usr/lib/python2.4/site-packages/django/newforms/fields.py in clean, line 396

The fix is checking that we have a file before passing it to PIL. My colleague Manuel Saelices has just uploaded an updated patch where this bug is fixed. Note there are some minor problems when applying the patch to django trunk, because it was made in the newforms-admin branch, to keep compatibility with previous patches.

comment:61 Changed 7 years ago by anonymous

  • Cc drackett@… added

comment:62 Changed 7 years ago by miracle2k <michael@…>

  • Cc elsdoerfer@… added

comment:63 Changed 7 years ago by simonbun <simonbun@…>

  • Cc django@… added

comment:64 Changed 7 years ago by anonymous

comment:65 Changed 7 years ago by stefan+django@…

when will this patch be included into trunk?

cheers,
stefan

Changed 7 years ago by stefan+django@…

patch against current trunk

Changed 7 years ago by Øyvind Saltvik <oyvind@…>

Updated to newforms admin 5741, proposal of new model field kwarg to allow some fields to be saved last. save_last=True

comment:66 Changed 7 years ago by Øyvind Saltvik <oyvind@…>

Updated patch to newforms-admin revision 5741.

Added a new kwarg to model fields to allow some fields to be saved last.

Example model

class Model(models.Model):
    file = models.FileField(upload_to='somedir', save_last=True)
    description = models.CharField(maxlength=100)
    category = models.ForeignKey(Category)

Would cause the field file to have access to those other fields set on the model and be able to save the model instance without missing required data if you need a pk/foreignkeys when saving the file .

comment:67 Changed 7 years ago by Brian Rosner <brosner@…>

This is looking good. Ticket #2070 which deals with streaming files just got approved for checkin. I would think that this would need to take some of the changes that ticket makes into consideration before this can get committed.

Changed 7 years ago by Øyvind Saltvik <oyvind@…>

Save on commit seems like a better idea.

Changed 7 years ago by Øyvind Saltvik <oyvind@…>

Missing paranthesis in last patch

Changed 7 years ago by Øyvind Saltvik <oyvind@…>

cleaner code

Changed 7 years ago by Øyvind Saltvik <oyvind@…>

Validation using ugettext instead of gettext

Changed 7 years ago by Øyvind Saltvik <oyvind@…>

Save later using non weak signals instead of save_instance modification.

comment:68 Changed 7 years ago by Øyvind Saltvik <oyvind@…>

Forgot to call save on the last patch. Calling save caused a eternal loop ofcourse. Don't program past bedtime. Sorry for all the mess.

Changed 7 years ago by Øyvind Saltvik <oyvind@…>

This one actually works and has comments.

comment:69 Changed 7 years ago by Øyvind Saltvik <oyvind@…>

Posting a new patch for specialized saving using a custom function, example follows.

class Model(models.Model):
    file = models.FileField(upload_to='files', save_to_function=lambda field, instance, filename: '%s_%s' % (instance._get_pk_val(), filename))

Changed 7 years ago by Øyvind Saltvik <oyvind@…>

Save to using a function

comment:70 Changed 7 years ago by Øyvind Saltvik <oyvind@…>

Valid example, requires null=True .

class Model(models.Model):
    file = models.FileField(null=True, upload_to='files', save_to_function=lambda field, instance, filename: '%s_%s' % (instance._get_pk_val(), filename))

Changed 7 years ago by russellm

File and Image fields, patch against trunk [5779]

comment:71 Changed 7 years ago by anonymous

  • Cc sam@… added

comment:72 Changed 7 years ago by ross@…

I'm of the opinion that this ticket should implement filefield and imagefield in newforms... and nothing else. Implementing file save-triggered functions and the like should be a separate ticket as it's new functionality that isn't necessarily required ot resolve this ticket.

The most recent patch by russellm, filefield-5779, applies against trunk 5784 and works if I say 'x = MyForm(request.POST, request.FILES)'.

comment:73 Changed 7 years ago by akaihola

  • Cc akaihol+djtick@… added

comment:74 Changed 7 years ago by russellm

  • Resolution set to fixed
  • Status changed from new to closed

(In [5819]) Fixed #3297 -- Implemented FileField and ImageField for newforms. Thanks to the many users that contributed to and tested this patch.

comment:75 Changed 7 years ago by russellm

(In [5828]) Merged revisions 4350-4357,4359-4365,4371-4372,4374-4377,4380-4386,4388,4390-4391,4400-4402,4404-4408,4410,4412-4419,4426-4427,4430-4432,4434,4441,4443-4444,4446-4447,4450,4452-4453,4455-4458,4476,4503,4546,4564-4569,4580-4586,4617,4630,4641-4643,4653-4655,4657,4669,4673-4675,4694-4696,4713-4714,4720-4723,4725-4732,4735-4741,4750,4755,4758,4769-4770,4776-4777,4783-4795,4798,4805-4808,4810,4813-4815,4817,4824,4836,4838-4843,4851-4855,4869,4872,4882-4884,4906,4916,4935-4936,4940-4944,4946-4953,4962-4963,4969,4971-4973,4990,4994-4997,5000-5003,5006-5008,5013-5014,5019-5024,5026-5036,5046-5047,5054-5059,5062,5079,5081-5083,5090,5100-5101,5114,5122-5123,5126,5128,5134-5136,5148-5149,5151,5157,5174,5178,5183-5185,5192-5195,5197-5200,5203,5205,5208,5214,5223-5224,5226-5227,5229-5230,5235-5236,5238-5244,5246-5249,5251,5254-5262,5266-5280,5282-5284,5286,5301,5307,5309-5310,5312,5314-5317,5319-5332,5334-5345,5372-5378,5381-5382,5384,5386,5388-5390,5393-5397,5399-5400,5416,5419-5430,5440-5441,5444-5448,5461-5464,5467,5473-5481,5487-5489,5491-5492,5498-5499,5507-5510,5512,5527,5529,5531-5535,5540-5541,5546,5570,5572-5574,5576-5578,5580-5581,5583-5589,5591,5595-5597,5601-5608,5613,5626-5826 via svnmerge from
http://code.djangoproject.com/svn/django/trunk

........

r5626 | russellm | 2007-07-07 10:16:23 +0800 (Sat, 07 Jul 2007) | 2 lines


Added some uncredited authors that worked on the Oracle branch.

........

r5629 | mtredinnick | 2007-07-08 01:15:54 +0800 (Sun, 08 Jul 2007) | 8 lines


Changed HttpRequest.path to be a Unicode object. It has already been
URL-decoded by the time we see it anyway, so keeping it as a UTF-8 bytestring
was causing unnecessary problems.


Also added handling for non-ASCII URL fragments in feed creation (the portion
that was outside the control of the Feed class was messed up).

........

r5630 | mtredinnick | 2007-07-08 02:24:27 +0800 (Sun, 08 Jul 2007) | 4 lines


Fixed #4772 -- Fixed reverse URL creation to work with non-ASCII arguments.
Also included a test for non-ASCII strings in URL patterns, although that
already worked correctly.

........

r5631 | mtredinnick | 2007-07-08 02:39:23 +0800 (Sun, 08 Jul 2007) | 3 lines


Corrected misleading comment from [5619]. Not sure what I was smoking at the
time.

........

r5632 | mtredinnick | 2007-07-08 08:39:32 +0800 (Sun, 08 Jul 2007) | 5 lines



Fixed reverse URL lookup using functions when the original URL pattern was a
string. This is now just as fragile as it was prior to [5609], but works in a
few cases that people were relying on, apparently.

........

r5636 | mtredinnick | 2007-07-08 19:22:53 +0800 (Sun, 08 Jul 2007) | 4 lines


Fixed #4798-- Made sure that function keyword arguments are strings (for the
keywords themselves) when using Unicode URL patterns.

........

r5638 | gwilson | 2007-07-10 10:34:42 +0800 (Tue, 10 Jul 2007) | 2 lines


Fixed #4817 -- Removed leading forward slashes from some urlconf examples in the documentation.

........

r5639 | gwilson | 2007-07-10 10:45:11 +0800 (Tue, 10 Jul 2007) | 2 lines


Fixed #4814 -- Fixed some whitespace issues in tutorial01, thanks John Shaffer.

........

r5640 | gwilson | 2007-07-10 11:26:26 +0800 (Tue, 10 Jul 2007) | 2 lines


Fixed #4812 -- Fixed an octal escape in regular expression that is used in the isValidEmail validator, thanks batchman@….

........

r5641 | mtredinnick | 2007-07-10 20:02:06 +0800 (Tue, 10 Jul 2007) | 3 lines


Fixed #4823 -- Fixed a Python 2.3 incompatibility from [5636] (it was even
demonstrated by existing tests, so I really screwed this up).

........

r5642 | mtredinnick | 2007-07-10 20:03:36 +0800 (Tue, 10 Jul 2007) | 3 lines


Fixed #4804 -- Fixed a problem when validating choice lists with non-ASCII
data. Thanks, django@….

........

r5643 | mtredinnick | 2007-07-10 20:33:55 +0800 (Tue, 10 Jul 2007) | 4 lines


Fixed #3760 -- Added the ability to manually set feed- and item-level id
elements in Atom feeds. This is fully backwards compatible. Based on a patch
from spark343@….

........

r5644 | mtredinnick | 2007-07-11 14:55:12 +0800 (Wed, 11 Jul 2007) | 3 lines


Fixed #4815 -- Fixed decoding of request parameters when the input encoding is
not UTF-8. Thanks, Jordan Dimov.

........

r5645 | mtredinnick | 2007-07-11 15:00:27 +0800 (Wed, 11 Jul 2007) | 3 lines


Fixed #4802 -- Updated French translation. Combined contribution from
baptiste.goupil@… and rocherl@….

........

r5646 | mtredinnick | 2007-07-11 15:12:50 +0800 (Wed, 11 Jul 2007) | 2 lines


Fixed #4753 -- Small update to Spanish translation from Mario Gonzalez.

........

r5649 | jacob | 2007-07-12 08:33:44 +0800 (Thu, 12 Jul 2007) | 1 line


Fixed #4615: corrected reverse URL resolution examples in tutorial 4. Thanks for the patch, simeonf.

........

r5650 | adrian | 2007-07-12 12:43:29 +0800 (Thu, 12 Jul 2007) | 1 line


Added 'New in Django development version' note to docs/syndication_feeds.txt changes from [5643]

........

r5651 | adrian | 2007-07-12 12:44:45 +0800 (Thu, 12 Jul 2007) | 1 line


Edited changes to docs/tutorial04.txt from [5649]

........

r5652 | adrian | 2007-07-12 13:23:47 +0800 (Thu, 12 Jul 2007) | 1 line


Added helpful error message to SiteManager.get_current() if the user hasn't set SITE_ID

........

r5653 | adrian | 2007-07-12 13:28:04 +0800 (Thu, 12 Jul 2007) | 1 line


Added RequestSite class to sites framework

........

r5654 | adrian | 2007-07-12 13:29:32 +0800 (Thu, 12 Jul 2007) | 1 line


Improved syndication feed framework to use RequestSite if the sites framework is not installed -- i.e., the sites framework is no longer required to use the syndication feed framework. This is backwards incompatible if anybody has subclassed Feed and overridden init(), because the second parameter is now expected to be an HttpRequest object instead of request.path

........

r5658 | russellm | 2007-07-12 15:45:35 +0800 (Thu, 12 Jul 2007) | 2 lines


Fixed #4459 -- Added 'raw' argument to save method, to override any pre-save processing, and modified serializers to use a raw-save. This enables serialization of DateFields with auto_now/auto_now_add. Also modified serializers to invoke save() directly on the model baseclass, to avoid any (potentially order-dependent, data modifying) behavior in a custom save() method.

........

r5659 | russellm | 2007-07-12 19:24:16 +0800 (Thu, 12 Jul 2007) | 2 lines


Fixed #3770 -- Remove null=True tag from OneToOne serialization test. OneToOne fields can't have a value of null.

........

r5660 | russellm | 2007-07-12 19:27:38 +0800 (Thu, 12 Jul 2007) | 2 lines


Fixed #3768 -- Disabled NullBooleanField PK serialization test. We can't and don't test null PK values.

........

r5662 | russellm | 2007-07-12 20:33:24 +0800 (Thu, 12 Jul 2007) | 2 lines


Fixed #4837 -- Updated Debian packaging details. Thanks for the suggestion, Yasushi Masuda <whosaysni@…>.

........

r5663 | russellm | 2007-07-12 20:44:05 +0800 (Thu, 12 Jul 2007) | 2 lines


Fixed #4808 -- Added Chilean regions in localflavor. Thanks, Marijn Vriens <marijn@…>.

........

r5664 | russellm | 2007-07-12 20:48:27 +0800 (Thu, 12 Jul 2007) | 2 lines


Fixed #4745 -- Updated docs to point out that 0 is not a valid SITE_ID when running the tests. Thanks for the suggestion, Lars Stavholm <stava@…>.

........

r5665 | russellm | 2007-07-12 20:50:02 +0800 (Thu, 12 Jul 2007) | 2 lines


Fixed #4763 -- Minor typo in cache documentations. Thanks, dan@….

........

r5666 | russellm | 2007-07-12 20:55:28 +0800 (Thu, 12 Jul 2007) | 2 lines


Fixed #4627 -- Added details on MacPorts packaging of Django. Thanks, Paul Bissex.

........

r5667 | russellm | 2007-07-12 21:23:11 +0800 (Thu, 12 Jul 2007) | 2 lines


Fixed #4640 -- Fixed import to stringfilter in docs. Proposed solution to move stringfilter into django.template.init introduces a circular import problem.

........

r5668 | russellm | 2007-07-12 21:32:00 +0800 (Thu, 12 Jul 2007) | 2 lines


Fixed #4722 -- Clarified discussion about PYTHONPATH in modpython docs. Thanks for the suggestion, Collin Grady <cgrady@…>.

........

r5669 | russellm | 2007-07-12 21:37:59 +0800 (Thu, 12 Jul 2007) | 2 lines


Fixed #4755 -- Modified newforms MultipleChoiceField to use list comprehension, rather than iteration.

........

r5670 | russellm | 2007-07-12 21:41:27 +0800 (Thu, 12 Jul 2007) | 2 lines


Fixed #4764 -- Added reference to Locale middleware in middleware docs. Thanks, dan@….

........

r5671 | russellm | 2007-07-12 21:55:19 +0800 (Thu, 12 Jul 2007) | 2 lines


Fixed #4768 -- Converted timesince and dateformat to use explicit floor division (pre-emptive avoidance of Python 3000 compatibility problem), and removed a redundant millisecond check. Thanks, John Shaffer <jshaffer2112@…>.

........

r5672 | russellm | 2007-07-12 22:00:13 +0800 (Thu, 12 Jul 2007) | 2 lines


Fixed #4775 -- Added some missing Hungarian accents to the urlify.js LATIN_MAP. Thanks, Pistahh <szekeres@…>.

........

r5673 | russellm | 2007-07-12 22:05:16 +0800 (Thu, 12 Jul 2007) | 2 lines


Fixed #4502 -- Clarified reference to view in tutorial. Thanks for the suggestion, Carl Karsten <carl@…>.

........

r5674 | russellm | 2007-07-12 22:11:41 +0800 (Thu, 12 Jul 2007) | 2 lines


Fixed #4522 -- Clarified the allowed filter arguments on the time and date filters. Thanks for the suggestion, admackin@….

........

r5675 | russellm | 2007-07-12 22:21:51 +0800 (Thu, 12 Jul 2007) | 2 lines


Fixed #4525 -- Fixed mistaken documentation on arguments to runfcgi. Thanks, Johan Bergstrom <bugs@…>.

........

r5676 | russellm | 2007-07-12 22:41:32 +0800 (Thu, 12 Jul 2007) | 2 lines


Fixed #4538 -- Split the installation instructions to differentiate between installing a distribution package and installing an official release. Thanks to Carl Karsten for the idea, and Paul Bissex for the patch.

........

r5677 | russellm | 2007-07-12 23:26:37 +0800 (Thu, 12 Jul 2007) | 2 lines


Fixed #4526 -- Modified the test Client login method to fail when a user is inactive. Thanks, marcin@….

........

r5678 | russellm | 2007-07-13 13:03:33 +0800 (Fri, 13 Jul 2007) | 2 lines


Fixed #3505 -- Added handling for the error raised when the user forgets the comma in a single element tuple when defining AUTHENTICATION_BACKENDS. Thanks for the help identifying this problem, Mario Gonzalez <gonzalemario@…>.

........

r5679 | mtredinnick | 2007-07-13 16:52:07 +0800 (Fri, 13 Jul 2007) | 3 lines


Fixed #2591 -- Fixed a problem with inspectdb with psycopg2 (only). Patch from
Gary Wilson.

........

r5680 | mtredinnick | 2007-07-13 17:09:59 +0800 (Fri, 13 Jul 2007) | 3 lines


Fixed #4807 -- Fixed a couple of corner cases in decimal form input validation.
Based on a suggestion from Chriss Moffit.

........

r5681 | mtredinnick | 2007-07-13 17:14:51 +0800 (Fri, 13 Jul 2007) | 3 lines


Fixed #4839 -- Added repr methods to URL classes that show the pattern they
contain. Thanks, Thomas G?\195?\188ttler.

........

r5682 | mtredinnick | 2007-07-13 18:56:30 +0800 (Fri, 13 Jul 2007) | 3 lines


Fixed #4842 -- Added slightly more robust error reporting. Thanks, Thomas
G?\195?\188ttler.

........

r5683 | mtredinnick | 2007-07-13 19:05:01 +0800 (Fri, 13 Jul 2007) | 3 lines


Fixed #4846 -- Fixed some Python 2.3 encoding problems in the admin interface.
Based on a patch from daybreaker12@….

........

r5684 | mtredinnick | 2007-07-13 20:03:20 +0800 (Fri, 13 Jul 2007) | 3 lines


Fixed #4861 -- Removed some duplicated logic from the newforms RegexField by
making it a subclass of CharField. Thanks, Collin Grady.

........

r5685 | mtredinnick | 2007-07-13 21:15:35 +0800 (Fri, 13 Jul 2007) | 3 lines


Fixed #4865 -- Replaced a stray generator comprehension with a list
comprehension so that we don't break Python 2.3.

........

r5686 | mtredinnick | 2007-07-13 22:13:35 +0800 (Fri, 13 Jul 2007) | 3 lines


Fixed #4469 -- Added slightly more informative error messages to max- and
min-length newform validation. Based on a patch from A. Murat Eren.

........

r5687 | mtredinnick | 2007-07-13 22:14:47 +0800 (Fri, 13 Jul 2007) | 2 lines


Added author credit for [5686]. Refs #4469.

........

r5688 | mtredinnick | 2007-07-13 22:33:46 +0800 (Fri, 13 Jul 2007) | 3 lines


Fixed #4484 -- Fixed APPEND_SLASH handling to handle an empty path value.
Thanks, VesselinK.

........

r5689 | mtredinnick | 2007-07-13 22:40:39 +0800 (Fri, 13 Jul 2007) | 2 lines


Fixed #4556 -- Stylistic changes to [5500]. Thanks, glin@….

........

r5690 | gwilson | 2007-07-14 04:36:01 +0800 (Sat, 14 Jul 2007) | 2 lines


Refs #2591 -- Removed int conversion and try/except since the value in the single-item list is already an int. I overlooked this in my original patch, which was applied in [5679].

........

r5691 | adrian | 2007-07-14 05:20:07 +0800 (Sat, 14 Jul 2007) | 1 line


Documented the 'commit' argument to save() methods on forms created via form_for_model() or form_for_instance()

........

r5692 | mtredinnick | 2007-07-14 13:27:22 +0800 (Sat, 14 Jul 2007) | 3 lines


Fixed #4869 -- Added a note that syncdb does not alter existing tables. Thanks,
James Bennett.

........

r5693 | mtredinnick | 2007-07-14 20:48:24 +0800 (Sat, 14 Jul 2007) | 3 lines


Fixed #4863 -- Removed comment references to a no-longer present link. Pointed
out by Thomas G?\195?\188ttler.

........

r5694 | mtredinnick | 2007-07-14 21:14:28 +0800 (Sat, 14 Jul 2007) | 2 lines


Fixed #4862 -- Fixed invalid Javascript creation in popup windows in admin.

........

r5695 | mtredinnick | 2007-07-14 21:39:41 +0800 (Sat, 14 Jul 2007) | 2 lines


Fixed a problem with translatable strings from [5686].

........

r5696 | mtredinnick | 2007-07-14 22:47:14 +0800 (Sat, 14 Jul 2007) | 3 lines


Fixed #4731 -- Changed management.setup_environ() so that it no longer assumes
the settings module is called "settings". Patch from SmileyChris.

........

r5697 | mtredinnick | 2007-07-14 22:50:35 +0800 (Sat, 14 Jul 2007) | 3 lines


Fixed #4870 -- Removed unneeded import and fixed a docstring in an example.
Thanks, Collin Grady.

........

r5698 | adrian | 2007-07-15 00:58:54 +0800 (Sun, 15 Jul 2007) | 1 line


Edited docs/db-api.txt changes from [5658]

........

r5699 | adrian | 2007-07-15 01:04:30 +0800 (Sun, 15 Jul 2007) | 1 line


Negligible capitalization fix in test/client.py docstring

........

r5700 | russellm | 2007-07-15 12:41:59 +0800 (Sun, 15 Jul 2007) | 2 lines


Clarified the documentation on the steps that happen during a save, and how raw save affects those steps.

........

r5701 | gwilson | 2007-07-15 13:03:28 +0800 (Sun, 15 Jul 2007) | 2 lines


Fixed #4310 -- Fixed a regular expression bug in strip_entities function and added tests for several django.utils.html functions. Based on patch from Brian Harring.

........

r5702 | gwilson | 2007-07-15 13:11:06 +0800 (Sun, 15 Jul 2007) | 2 lines


Fixed #4877 -- Fixed typo in testing documentation, patch from John Shaffer.

........

r5703 | gwilson | 2007-07-15 14:24:54 +0800 (Sun, 15 Jul 2007) | 2 lines


Fixed #3012 -- Changed the locmem cache backend to use pickle instead of deepcopy to make it compatible with iterators (which cannot be copied). Patch from Sundance.

........

r5704 | gwilson | 2007-07-15 14:29:45 +0800 (Sun, 15 Jul 2007) | 2 lines


Changed imports to adhere to PEP 8.

........

r5705 | mtredinnick | 2007-07-15 17:39:13 +0800 (Sun, 15 Jul 2007) | 3 lines


Fixed #4880 -- Updated Spanish translation (includes re-encoding to UTF-8).
Thanks, Jorge Gajon.

........

r5706 | mtredinnick | 2007-07-15 17:46:42 +0800 (Sun, 15 Jul 2007) | 3 lines


Fixed #4882 -- Updated Argentinean Spanish translation (includes re-encoding to
UTF-8). Thanks, Ramiro Morales.

........

r5707 | mtredinnick | 2007-07-15 18:08:05 +0800 (Sun, 15 Jul 2007) | 3 lines


Re-encoded djangojs.po for French and German locales to UTF-8. These were the
last two non-UTF-8 PO files.

........

r5708 | mtredinnick | 2007-07-15 18:10:44 +0800 (Sun, 15 Jul 2007) | 6 lines


Fixed #4734 -- Changed message extraction to permit non-ACSII msgid strings.
Thanks, krzysiek.pawlik@….


This is slightly backwards-incompatible for translators: PO files are now
assumed to be in UTF-8 encoding.

........

r5709 | adrian | 2007-07-16 03:34:21 +0800 (Mon, 16 Jul 2007) | 1 line


Edited docs/db-api.txt changes from [5700]

........

r5710 | adrian | 2007-07-16 05:16:32 +0800 (Mon, 16 Jul 2007) | 1 line


Improved docs/templates.txt section on the 'regroup' tag

........

r5711 | mtredinnick | 2007-07-16 11:48:03 +0800 (Mon, 16 Jul 2007) | 2 lines


Updated AUTHORS for [5708].

........

r5712 | mtredinnick | 2007-07-16 11:50:22 +0800 (Mon, 16 Jul 2007) | 3 lines


Fixed #4199 -- Changed date formatting in HTTP expires header to be spec
compliant. Thanks, Chris Bennett.

........

r5713 | mtredinnick | 2007-07-16 12:45:45 +0800 (Mon, 16 Jul 2007) | 3 lines


Fixed #4884 -- Fixed an initialisation problem when assigned to settings before
accessing them. Thanks, Noam Raphael.

........

r5714 | mtredinnick | 2007-07-16 12:47:52 +0800 (Mon, 16 Jul 2007) | 2 lines


Fixed #4806 -- Updated Simplified Chinese translation. Thanks, limodou.

........

r5715 | mtredinnick | 2007-07-16 12:54:49 +0800 (Mon, 16 Jul 2007) | 3 lines


Fixed #4887 -- Fixed another place where template tag arguments are used
directly as function keyword args. Thanks, Brian Rosner.

........

r5716 | gwilson | 2007-07-16 13:00:18 +0800 (Mon, 16 Jul 2007) | 2 lines


Refs #3012 -- Removed iterator from test_data_types cache test that I added in [5703]. Iterators cannot be pickled either. Left the rest of [5703] there though since it fixed another issue that was causing the test_data_types cache test to fail with the locmem cache backend, the fact that functions cannot be copied.

........

r5717 | gwilson | 2007-07-16 13:28:13 +0800 (Mon, 16 Jul 2007) | 2 lines


Cleaned up a couple unused imports and fixed docstrings to follow Python Style Guide.

........

r5718 | mtredinnick | 2007-07-16 17:36:10 +0800 (Mon, 16 Jul 2007) | 3 lines


Fixed #4845 -- Fixed some problems with Unicode usage and caching. Thanks,
Jeremy Dunck.

........

r5719 | gwilson | 2007-07-16 21:47:43 +0800 (Mon, 16 Jul 2007) | 2 lines


Removed unused variable and changed comments about permalink decorator into a docstring.

........

r5720 | gwilson | 2007-07-17 06:29:09 +0800 (Tue, 17 Jul 2007) | 2 lines


Fixed #4851 -- Fixed description of an example query in db-api docs.

........

r5721 | mtredinnick | 2007-07-17 12:22:11 +0800 (Tue, 17 Jul 2007) | 2 lines


Fixed #4898 -- Fixed a precendence problem when constructing HTTP Date header.

........

r5722 | mtredinnick | 2007-07-17 18:25:43 +0800 (Tue, 17 Jul 2007) | 3 lines


Fixed #4899 -- Fixed a problem with PO file header generation caused by [5708].
Thanks, Ramiro Morales.

........

r5723 | mtredinnick | 2007-07-19 17:23:45 +0800 (Thu, 19 Jul 2007) | 2 lines


Fixed #4917 -- Updated Swedish translation. Thanks, Pilip Lindborg.

........

r5724 | mtredinnick | 2007-07-19 17:24:36 +0800 (Thu, 19 Jul 2007) | 2 lines


Fixed #3925 -- Added Slovak localflavor items. Thanks, Martin Kos?\195?\173r.

........

r5725 | adrian | 2007-07-20 14:28:56 +0800 (Fri, 20 Jul 2007) | 1 line


Added a db_type() method to the database Field class. This is a hook for calculating the database column type for a given Field. Also converted all management.py CREATE TABLE statements to use db_type(), which made that code cleaner. The Field.get_internal_type() hook still exists, but we should consider removing it at some point, because db_type() is more general. Also added docs -- the beginnings of docs on how to create custom database Field classes. This is backwards-compatible.

........

r5726 | adrian | 2007-07-20 14:34:26 +0800 (Fri, 20 Jul 2007) | 1 line


Simplified the indent level in management.py _get_sql_model_create() by using a 'continue' statement rather than nesting everything in an 'if'

........

r5727 | russellm | 2007-07-20 20:07:58 +0800 (Fri, 20 Jul 2007) | 2 lines


Fixed #4558 -- Modified XML serializer to handle whitespace better around None tags. Thanks to Bill Fenner <fenner@…> for the report and fix.

........

r5728 | russellm | 2007-07-20 20:15:02 +0800 (Fri, 20 Jul 2007) | 2 lines


Fixed #4897 -- Fixed minor typo in doctest comment.

........

r5729 | russellm | 2007-07-20 21:57:49 +0800 (Fri, 20 Jul 2007) | 2 lines


Fixed #3782 -- Added support for the suite() method recommended by the Python unittest docs. Thanks for the suggestion, rene.puls@….

........

r5730 | russellm | 2007-07-20 22:07:54 +0800 (Fri, 20 Jul 2007) | 2 lines


Refs #3782 -- Added documentation note that suite() handling is only in development version.

........

r5731 | russellm | 2007-07-20 22:32:20 +0800 (Fri, 20 Jul 2007) | 2 lines


Fixed #4901 -- Modified assertContains to provide a default check of 'any instances of text in content'. Thanks for the suggestion, nis@….

........

r5732 | russellm | 2007-07-20 22:42:57 +0800 (Fri, 20 Jul 2007) | 2 lines


Fixed #4738 -- Modified the prompt that is displayed when a test database cannot be created. The existing prompt was misleading if the issue wasn't a pre-existing database. Thanks for the suggestion, John Shaffer <jshaffer2112@…>.

........

r5733 | adrian | 2007-07-20 23:40:54 +0800 (Fri, 20 Jul 2007) | 1 line


Fixed negligible typo in docstring in tests/regressiontests/test_client_regress/models.py from [5731]

........

r5736 | adrian | 2007-07-21 05:24:30 +0800 (Sat, 21 Jul 2007) | 1 line


Added some additional docs to docs/model-api.txt db_type() section

........

r5738 | russellm | 2007-07-21 11:30:38 +0800 (Sat, 21 Jul 2007) | 2 lines


Fixed #4304 -- Modified sys.exit to os._exit to make sure development server quits when an error occurs attempting to bind to the requested port (e.g., if another server is already running). Thanks, Mario Gonzalez <gonzalemario@…>.

........

r5739 | russellm | 2007-07-21 12:36:28 +0800 (Sat, 21 Jul 2007) | 2 lines


Minor fix to allow for count=0 in assertContains.

........

r5740 | russellm | 2007-07-21 13:15:19 +0800 (Sat, 21 Jul 2007) | 2 lines


Added test cases for change [5739].

........

r5741 | russellm | 2007-07-21 13:17:20 +0800 (Sat, 21 Jul 2007) | 2 lines


Fixed #4402 -- Modified test client to allow multi-valued inputs on GET requests. Thanks for the suggestion, eddymul@….

........

r5743 | gwilson | 2007-07-22 10:18:36 +0800 (Sun, 22 Jul 2007) | 2 lines


Fixed #4945 -- Removed unused GET_ITERATOR_CHUNK_SIZE definition from manager.py. GET_ITERATOR_CHUNK_SIZE is already defined in query.py. Thanks zigiDev@….

........

r5744 | gwilson | 2007-07-22 11:09:24 +0800 (Sun, 22 Jul 2007) | 2 lines


Added docstrings to shortcuts module and functions.

........

r5745 | gwilson | 2007-07-22 11:12:50 +0800 (Sun, 22 Jul 2007) | 2 lines


Shortcut functions do not accept QuerySet objects, yet :)

........

r5746 | gwilson | 2007-07-22 11:41:11 +0800 (Sun, 22 Jul 2007) | 2 lines


Fixed #4373 -- Modified the get_object_or_404/get_list_or_404 shortcuts to also accept QuerySets. Thanks SuperJared.

........

r5747 | gwilson | 2007-07-22 11:45:03 +0800 (Sun, 22 Jul 2007) | 2 lines


Corrected typo in [5746].

........

r5750 | gwilson | 2007-07-23 12:45:01 +0800 (Mon, 23 Jul 2007) | 2 lines


Fixed #4952 -- Fixed the get_template_sources functions of the app_directories and filesystem template loaders to not return paths outside of given template directories. Both functions now make use of a new safe_join utility function. Thanks to SmileyChris for help with the patch.

........

r5752 | russellm | 2007-07-23 20:14:32 +0800 (Mon, 23 Jul 2007) | 2 lines


Fixed #3771 -- Modified the test runner to observe the --noinput argument controlling script interactivity. This means that test scripts can now be put in a buildbot environment. This is a backwards incompatible change for anyone that has written a custom test runner. Thanks for the suggestion, moof@….

........

r5753 | russellm | 2007-07-23 21:52:59 +0800 (Mon, 23 Jul 2007) | 2 lines


Added documentation for a test runner argument that has always been present, but was undocumented.

........

r5756 | adrian | 2007-07-25 11:12:31 +0800 (Wed, 25 Jul 2007) | 1 line


Changed docstring additions from [5744] to use active verbs ('returns' instead of 'return')

........

r5757 | adrian | 2007-07-25 11:15:05 +0800 (Wed, 25 Jul 2007) | 1 line


Added 'New in Django development version' to docs/db-api.txt change from [5746]

........

r5758 | adrian | 2007-07-25 11:18:17 +0800 (Wed, 25 Jul 2007) | 1 line


Changed safe_join() docstring from [5750] to use active verbs. See also [5756]

........

r5764 | gwilson | 2007-07-26 13:01:53 +0800 (Thu, 26 Jul 2007) | 2 lines


Fixed #4971 -- Fixed some escaping and quoting problems in the databrowse contrib app. Based on patch from Johann Queuniet.

........

r5765 | adrian | 2007-07-27 01:16:34 +0800 (Fri, 27 Jul 2007) | 1 line


Added section to docs/contributing.txt about docstring coding style

........

r5766 | mtredinnick | 2007-07-27 06:59:34 +0800 (Fri, 27 Jul 2007) | 2 lines


Added support for database cache table in test database.

........

r5767 | adrian | 2007-07-28 05:53:02 +0800 (Sat, 28 Jul 2007) | 1 line


Added unit test that confirms a bug in ValuesQuerySets that have extra(select) specified. If the select dictionary has several fields, Django assigns the wrong values to the select-field names

........

r5768 | adrian | 2007-07-28 06:07:42 +0800 (Sat, 28 Jul 2007) | 1 line


Fixed bug with using values() and extra(select) in the same QuerySet, with a select dictionary containing more than a few elements. This bug was identified in unit test from [5767]. The problem was that we were relying on the dictionary's .items() ordering, which is undefined

........

r5769 | russellm | 2007-07-28 12:02:52 +0800 (Sat, 28 Jul 2007) | 2 lines


Fixed #4460 -- Added the ability to be more specific in the test cases that are executed. This is a backwards incompatible change for any user with a custom test runner. See the wiki for details.

........

r5770 | russellm | 2007-07-28 15:27:53 +0800 (Sat, 28 Jul 2007) | 2 lines


Fixed #4995 -- Fixed some problems in documentation ReST formatting. Thanks, Simon G.

........

r5771 | simon | 2007-07-29 02:30:40 +0800 (Sun, 29 Jul 2007) | 1 line


After discussing with Malcolm, added set_unusable_password() and has_usable_password() methods to the User object, plus tests and updated documentation

........

r5774 | adrian | 2007-07-30 02:21:16 +0800 (Mon, 30 Jul 2007) | 1 line


Added 'New in Django development version' to changes in docs/authentication.txt from [5771]

........

r5778 | gwilson | 2007-07-31 01:25:35 +0800 (Tue, 31 Jul 2007) | 4 lines


Fixed call to ugettext, which is imported as _.
Changed raise to conform to PEP 3109 and wrapped the long line.
Added beginnings of tests for model fields.

........

r5782 | gwilson | 2007-08-01 13:41:32 +0800 (Wed, 01 Aug 2007) | 2 lines


Fixed #4228 -- Removed hardcoding of RadioFieldRenderer in the RadioSelect Widget so that the display of RadioSelects can be more easily customized. BoundField.__unicode__ also no longer special cases RadioSelect since RadioSelect.render() now returns a string like every other Widget.

........

r5783 | gwilson | 2007-08-01 13:52:18 +0800 (Wed, 01 Aug 2007) | 2 lines


Fixed #5037 -- Fixed use of wrong field type in a db-api docs example, thanks ubernostrum.

........

r5796 | gwilson | 2007-08-04 11:19:14 +0800 (Sat, 04 Aug 2007) | 2 lines


Fixed #5078 -- Fixed several broken links to the syndication documentation.

........

r5797 | gwilson | 2007-08-04 11:36:58 +0800 (Sat, 04 Aug 2007) | 2 lines


Changed the 0.95 release notes to point to the 0.95 documentation index.

........

r5798 | gwilson | 2007-08-04 11:39:24 +0800 (Sat, 04 Aug 2007) | 2 lines


Changed several documentation links to be relative.

........

r5799 | gwilson | 2007-08-04 22:41:49 +0800 (Sat, 04 Aug 2007) | 2 lines


Refs #3397 -- Corrected the Exception that is caught when ordering by non-fields (added in [4596]), thanks glin@….

........

r5800 | gwilson | 2007-08-04 22:52:13 +0800 (Sat, 04 Aug 2007) | 2 lines


Fixed #5083 -- Fixed typo in newforms documentation, thanks Rik.

........

r5801 | gwilson | 2007-08-05 12:39:52 +0800 (Sun, 05 Aug 2007) | 2 lines


Refs #5089 -- Added file name to poll detail template examples in the tutorial.

........

r5802 | gwilson | 2007-08-05 12:42:26 +0800 (Sun, 05 Aug 2007) | 2 lines


Changed some more links to be relative in the documentation. I had a couple unsaved files that didn't get in with [5798].

........

r5803 | gwilson | 2007-08-05 13:14:46 +0800 (Sun, 05 Aug 2007) | 2 lines


Fixed #2101 -- Renamed maxlength argument to max_length for oldforms FormFields and db model Fields. This is fully backwards compatible at the moment since the legacy maxlength argument is still supported. Using maxlength will, however, issue a PendingDeprecationWarning when used.

........

r5804 | russellm | 2007-08-05 15:39:36 +0800 (Sun, 05 Aug 2007) | 2 lines


Fixed #4001 -- Added dynamic save_m2m method() to forms created with form_for_model and form_for_instance on save(commit=False).

........

r5807 | adrian | 2007-08-06 12:36:43 +0800 (Mon, 06 Aug 2007) | 1 line


Fixed #5074 -- Added link to audio clip of 'Django' pronunciation

........

r5808 | adrian | 2007-08-06 12:52:14 +0800 (Mon, 06 Aug 2007) | 1 line


Edited docs/newforms.txt changes from [5804]

........

r5809 | adrian | 2007-08-06 13:04:27 +0800 (Mon, 06 Aug 2007) | 1 line


Fixed #5082 -- Enabled tab completion in 'django-admin.py shell' for objects that were imported into the global namespace at runtime. Thanks, dusk@…

........

r5810 | adrian | 2007-08-06 13:06:15 +0800 (Mon, 06 Aug 2007) | 1 line


Fixed #5077 -- django/utils/encoding.py no longer imports settings, as it doesn't use that module. Thanks, Collin Grady

........

r5811 | adrian | 2007-08-06 13:07:38 +0800 (Mon, 06 Aug 2007) | 1 line


Fixed #5071 -- Fixed 'global name ugettext is not defined' error in django.core.validators. Thanks, Marco Bonetti

........

r5812 | adrian | 2007-08-06 13:13:06 +0800 (Mon, 06 Aug 2007) | 1 line


Fixed #5064 -- Fixed potentially confusing sentence in docs/authentication.txt. Thanks, Collin Grady

........

r5813 | adrian | 2007-08-06 13:16:35 +0800 (Mon, 06 Aug 2007) | 1 line


Fixed #5053 -- Added 'action' attribute to <form> tags that didn't have that attribute in docs/newforms.txt examples. Perfectionism appreciated, trickyb

........

r5814 | adrian | 2007-08-06 13:27:58 +0800 (Mon, 06 Aug 2007) | 1 line


Added a closing </p>' to a code example in docs/email.txt

........

r5815 | adrian | 2007-08-06 13:28:45 +0800 (Mon, 06 Aug 2007) | 1 line


Fixed #5006 -- Fixed incorrect/outdated docstring for the 'if' template tag. Thanks, Thomas Petazzoni

........

r5816 | adrian | 2007-08-06 13:33:18 +0800 (Mon, 06 Aug 2007) | 1 line


Added note to docs/model-api.txt about help_text not being escaped in the admin interface

........

r5817 | adrian | 2007-08-06 13:34:45 +0800 (Mon, 06 Aug 2007) | 1 line


Fixed #4985 -- Clarified location of HttpResponse in docs/request_response.txt. Thanks for raising the issue, rainer.mansfeld@…

........

r5818 | adrian | 2007-08-06 13:37:17 +0800 (Mon, 06 Aug 2007) | 1 line


Fixed #4980 -- Removed 'forms' from the 'not considered stable and will be rewritten' section of docs/api_stability.txt. They've already been rewritten.

........

r5819 | russellm | 2007-08-06 21:58:56 +0800 (Mon, 06 Aug 2007) | 2 lines


Fixed #3297 -- Implemented FileField and ImageField for newforms. Thanks to the many users that contributed to and tested this patch.

........

r5820 | russellm | 2007-08-06 22:17:10 +0800 (Mon, 06 Aug 2007) | 2 lines


Added note that FileField and ImageField are only in development version. There are also some minor backwards compatibility issues with the changes introduced in [5819] - see the wiki for details.

........

r5823 | adrian | 2007-08-07 04:27:04 +0800 (Tue, 07 Aug 2007) | 1 line


Fixed British spelling of 'customize' and 'behavior' in Manager.get_query_set() docstring

........

r5824 | adrian | 2007-08-07 10:18:36 +0800 (Tue, 07 Aug 2007) | 1 line


Fixed #5105 -- Fixed two ReST errors in docs/newforms.txt. Thanks, Ramiro Morales

........

r5825 | adrian | 2007-08-07 10:33:11 +0800 (Tue, 07 Aug 2007) | 1 line


Fixed #5097 -- Made various updates and corrections to the documentation. Thanks, Nicola Larosa

........

r5826 | russellm | 2007-08-07 19:20:15 +0800 (Tue, 07 Aug 2007) | 2 lines


Removed a redundant directory join during FileField form saving. Thanks to David Danier's eagle eyes for picking up this one.

........

comment:76 Changed 7 years ago by robert.coup@…

See #5029 for issues around renaming files.

Add Comment

Modify Ticket

Change Properties
<Author field>
Action
as closed
as The resolution will be set. Next status will be 'closed'
The resolution will be deleted. Next status will be 'new'
Author


E-mail address and user name can be saved in the Preferences.

 
Note: See TracTickets for help on using tickets.